Attribute VB_Name = "basX"
Option Compare Database
Option Explicit
'
'For this constant: vbext_pk_Proc. A reference need to be added:
'   "Microsoft Visual Basic for Applications Extensibility 5.3"
'or just add a contant: const vbext_pk_Proc as long = 0
'These functions can be used to change/search code in forms and modules or queries.
'My plan was to create a way to cross reference all properties and objects.
'This is what i have so far.
'
'Feel free to modify, change and improve. As long as you post the result on this forum for other people to use.
'
'The VB_Beautifier procedure indents all your code nicely.
'the VB_BeautifierModule beautifies a single module.
'
' By Guus2005 (2007)
'
' Additional source: Access Helpfiles and Internet.
'
'Last modification dd 2007-10-22 (yyyy-mm-dd)

Const cDEFAULTTABWIDTH As Integer = 4

Public Sub VB_Beautifier(strModname As String, strProcname As String, Optional intTabWidth As Integer = cDEFAULTTABWIDTH)
'This procedure checkes line by line if the tab width is correct. Ignore comment
    Dim intStartProc        As Integer
    Dim intProcLines        As Integer
    Dim mod1                As Module
    Dim intLevel            As Integer 'Determine what level
    Dim lngX                As Long
    Dim strLine             As String
    Dim blnLineContinuation As Boolean
    Dim strRawInput         As String
    Dim strFirstWord        As String
    Dim strSecondWord       As String
    Dim strFirstChar        As String
    Dim strMes              As String
    Dim strChangedLine      As String
    Dim lngY                As Long
    Dim intLvlDoLoop        As Integer 'Do Loop While Wend

    On Error GoTo Err_VB_Beautifier

    Set mod1 = OpenModule(strModname)
    If mod1 Is Nothing Then 'Controle
        MsgBox "Module '" & strModname & "' can not be opened", vbExclamation, GetAppTitle()
        Exit Sub
    End If

    intStartProc = mod1.ProcStartLine(strProcname, vbext_pk_Proc) 'vbext_pk_Proc = 0
    intProcLines = mod1.ProcCountLines(strProcname, vbext_pk_Proc)

    blnLineContinuation = False
    intLevel = 1

    For lngX = intStartProc To intStartProc + intProcLines - 1
'Line by line check

        strRawInput = mod1.Lines(lngX, 1)
        strLine = VBA.Trim$(strRawInput)

'        DebugPrint strProcname, lngX & " - " & Nz(strLine, "NULL")

        If Not blnLineContinuation Then
            If InStr(1, strLine, " ") > 0 Then
                strFirstWord = GetPart(strLine, " ", 1)
                strSecondWord = GetPart(strLine, " ", 2)
            Else
                strFirstWord = strLine 'Sentence without spaces
                strSecondWord = ""
            End If
            strFirstChar = VBA.Left$(strLine, 1)
        Else
            strFirstWord = ""
        End If

        If strFirstChar = "'" Then strFirstWord = strFirstChar

        If strFirstWord = "If" Or blnLineContinuation Then
            lngY = InStr(1, strLine, " Then ")
            If lngY > 0 Then
                If VBA.Left$(VBA.Trim$(VBA.Right$(strLine, Len(strLine) - lngY - 4)), 1) <> "'" Then
                    strFirstWord = "IFTHEN"
                    If blnLineContinuation Then intLevel = intLevel - 1
                End If
            End If
        End If

        blnLineContinuation = False

        Select Case LCase$(strFirstWord)
        Case "public", "'", "", "private", "sub", "function" 'special statement, stay on this level.
            strChangedLine = strRawInput
'            DebugPrint strProcname, "lngX:" & lngX & " - " & Nz(strChangedLine, "NullValue")
            ReplaceLines mod1, lngX, Nz(strChangedLine, "NullValue")
        Case "for", "until", "if", "do", "while", "select"       'Increase level
            strChangedLine = Space(intTabWidth * intLevel) & LTrim$(strLine)
'            DebugPrint strProcname, intLevel & " " & strChangedLine
            ReplaceLines mod1, lngX, strChangedLine
            intLevel = intLevel + 1
        Case "next", "end", "wend", "loop"                       'Decrease level
            intLevel = intLevel - 1
            If intLevel < 0 Then intLevel = 0
            strChangedLine = Space(intTabWidth * intLevel) & LTrim$(strLine)
'            DebugPrint strProcname, intLevel & " " & strChangedLine
            ReplaceLines mod1, lngX, strChangedLine
        Case "else", "elseif", "case"                           'Decrease level print and increase level again
            intLevel = intLevel - 1
            If intLevel < 0 Then intLevel = 0
            strChangedLine = Space(intTabWidth * intLevel) & LTrim$(strLine)
'            DebugPrint strProcname, intLevel & " " & strChangedLine
            ReplaceLines mod1, lngX, strChangedLine
            intLevel = intLevel + 1
        Case Else ' "'", "" 'Do nothing, stay on this level
            strChangedLine = Space(intTabWidth * intLevel) & LTrim$(strLine)
'           DebugPrint strProcname, intLevel & " " & strChangedLine
            ReplaceLines mod1, lngX, strChangedLine
        End Select

        blnLineContinuation = VBA.Right$(strLine, 1) = "_"

    Next lngX

Exit_VB_Beautifier:
    Exit Sub
Err_VB_Beautifier:
    strMes = "VB_Beautifier " & vbCrLf & vbCrLf & "Errorline: " & Erl & " - " & Err.Description
    MsgBox strMes, vbExclamation, "VB_Beautifier"
    Resume Exit_VB_Beautifier
    Resume
End Sub

Public Sub VB_BeautifierModule(strModname As String, Optional intTabWidth As Integer = cDEFAULTTABWIDTH)

    Dim mod1            As Module
    Dim astrProcNames() As String
    Dim intI            As Integer

    Set mod1 = OpenModule(strModname)

    astrProcNames = AllProcs(mod1)

'loop through all procedures
    For intI = 0 To UBound(astrProcNames)
        Debug.Print astrProcNames(intI)
        VB_Beautifier strModname, astrProcNames(intI), intTabWidth
    Next intI

End Sub

Private Function AllProcs(mdl As Module) As Variant

    Dim lngI            As Long
    Dim lngR            As Long
    Dim intI            As Integer
    Dim lngCount        As Long
    Dim strProcname     As String
    Dim lngCountDecl    As Long
    Dim astrProcNames() As String 'Array of procedure names

' Count lines in module.
    lngCount = mdl.CountOfLines

' Count lines in Declaration section in module.
    lngCountDecl = mdl.CountOfDeclarationLines

' Determine name of first procedure.
    strProcname = mdl.ProcOfLine(lngCountDecl + 1, lngR)

' Initialize counter variable.
    intI = 0

' Redimension array.
    ReDim Preserve astrProcNames(intI)

'Is a procedure found
    If Len(strProcname) = 0 Then 'No procedures found
        AllProcs = astrProcNames
        Exit Function
    End If

' Store name of first procedure in array.
    astrProcNames(intI) = strProcname

' Determine procedure name for each line after declarations.
    For lngI = lngCountDecl + 1 To lngCount
' Compare procedure name with ProcOfLine property value.
        If strProcname <> mdl.ProcOfLine(lngI, lngR) Then
' Increment counter.
            intI = intI + 1
            strProcname = mdl.ProcOfLine(lngI, lngR)
            ReDim Preserve astrProcNames(intI)
' Assign unique procedure names to array.
            astrProcNames(intI) = strProcname
        End If
    Next lngI

    AllProcs = astrProcNames

End Function
Public Sub CloseAllForms()

    Dim obj1 As AccessObject

    For Each obj1 In Application.CurrentProject.AllForms
        If obj1.IsLoaded Then DoCmd.Close acForm, obj1.Name
    Next obj1

End Sub

Private Sub DeletefromForms(strFormname As String)
    Dim mod1 As Module, strType As String

'If form has module, then check contents of first line
'for "Module", and delete the first line if it is present.
'Free module reference resource when done.
    If Forms(strFormname).HasModule = True Then
        Set mod1 = Forms(strFormname).Module
        If mod1.Find("Module", 1, 1, 1, 40) = True Then
            mod1.DeleteLines 1, 1
        End If
        Set mod1 = Nothing
    End If
End Sub

Private Sub DeletefromModules(modname)
    Dim mod1 As Module

    Set mod1 = Modules(modname)

'Delete first line if first 40 characters
'contain "Module".
    If mod1.Find("Module", 1, 1, 1, 40) = True Then
        mod1.DeleteLines 1, 1
    End If
    Set mod1 = Nothing
End Sub

Private Sub DoesFormHaveModule(frmname)
'Only print form name if it has a module.
    If Forms(frmname).HasModule = True Then
        Debug.Print frmname & vbTab & "Form Class Module"
    End If
End Sub

Public Sub EnumAllforms()
    Dim obj1 As AccessObject
    Dim mod1 As Module

'Loop through AllForms members;
    For Each obj1 In Application.CurrentProject.AllForms
        If obj1.IsLoaded Then
            If Forms(obj1.Name).HasModule = True Then
                Set mod1 = Forms(obj1.Name).Module
                mod1.InsertLines 1, "'Form Class Module"
                Set mod1 = Nothing
            End If
        Else
            DoCmd.OpenForm obj1.Name
            InsertIntoForms obj1.Name
            DoCmd.Close acForm, obj1.Name, acSaveYes
        End If
    Next obj1

End Sub

Private Sub EnumerateAllFormstoDelete()
    Dim obj1 As AccessObject

'Loop through AllForms members;
'if form is loaded invoke module to remove line,
'else open form first and then close afterwards.
    For Each obj1 In Application.CurrentProject.AllForms
        If obj1.IsLoaded Then
            DeletefromForms obj1.Name
        Else
            DoCmd.OpenForm obj1.Name
            DeletefromForms obj1.Name
            DoCmd.Close acForm, obj1.Name, acSaveYes
        End If
    Next obj1
End Sub

Private Sub EnumerateAllFormsToInsert()
    Dim obj1 As AccessObject

'Loop through AllForms members;
'if form is loaded invoke module to insert line,
'else open form first and then close afterwards.
    For Each obj1 In Application.CurrentProject.AllForms
        If obj1.IsLoaded Then
            InsertIntoForms obj1.Name
        Else
            DoCmd.OpenForm obj1.Name
            InsertIntoForms obj1.Name
            DoCmd.Close acForm, obj1.Name, acSaveYes
        End If
    Next obj1
End Sub


Public Sub EnumerateAllModules()
    Dim obj1 As AccessObject
    For Each obj1 In Application.CurrentProject.AllModules
        Debug.Print obj1.Name & vbTab & obj1.Type & vbTab & obj1.IsLoaded
    Next obj1
End Sub

Private Sub EnumerateAllModulestoDelete()
    Dim obj1 As AccessObject, dbs As Object
    Dim mod1 As Module, frm1 As Form

'Loop through AllModules members.
'If module is open, call sub to delete line;
'else open module first, then close afterwards.
    For Each obj1 In Application.CurrentProject.AllModules
        If obj1.IsLoaded = True Then
            DeletefromModules obj1.Name
        Else
            DoCmd.OpenModule obj1.Name
            DeletefromModules obj1.Name
            DoCmd.Close acModule, obj1.Name
        End If
    Next obj1
End Sub

Private Sub EnumerateAllModulestoInsert()
    Dim obj1 As AccessObject

'Loop through AllModules members.
'If module is open, call sub to insert lines;
'else open module first, then close afterwards.
    For Each obj1 In Application.CurrentProject.AllModules
        If obj1.IsLoaded = True Then
            InsertIntoModules obj1.Name
        Else
            DoCmd.OpenModule obj1.Name
            InsertIntoModules obj1.Name
            DoCmd.Close acModule, obj1.Name, acSaveYes
        End If
    Next obj1
End Sub

Private Sub EnumerateAllViews2()
    Dim obj1 As AccessObject, dbs1 As Object
    Set dbs1 = Application.CurrentData
    If Application.CurrentProject.ProjectType = acADP Then
        For Each obj1 In dbs1.AllViews
            Debug.Print obj1.Name & vbTab & obj1.Type & _
vbTab & obj1.IsLoaded
        Next obj1
        For Each obj1 In dbs1.AllStoredProcedures
            Debug.Print obj1.Name & vbTab & obj1.Type & _
vbTab & obj1.IsLoaded
        Next obj1
    Else
        For Each obj1 In dbs1.AllQueries
            Debug.Print obj1.Name & vbTab & obj1.Type & _
vbTab & obj1.IsLoaded
        Next obj1
    End If
End Sub

Public Function FakeFunction()
'Loop through all queries to see if their name is used in queries.
'Default only the queries not used in queries are shown.

    Dim qdf As QueryDef
    Dim blnFound As Boolean
    Dim strRetVal As String

    For Each qdf In CurrentDb.QueryDefs
        If VBA.Left$(qdf.Name, 4) <> "~sq_" Then
            strRetVal = SearchAllModules(qdf.Name, False)
            blnFound = Len(strRetVal) > 0
            If blnFound Then
                Debug.Print strRetVal
            End If
        End If
    Next qdf

    If MsgBox("Close all forms?", vbQuestion + vbYesNo, GetAppTitle) = vbYes Then CloseAllForms

    MsgBox "Done!", vbInformation, "XrefQueriesInFormCode: Search completed"

End Function

Public Sub FindInModule(strModname As String, strSearchString As String)
'Delete lines in specific module where searchstring was found
    Dim mod1 As Module

    Set mod1 = Modules(strModname)

'Delete first line if first 40 characters
'contain strSearchString
    If mod1.Find(strSearchString, 1, 1, 1, 40) = True Then
        mod1.DeleteLines 1, 1
    End If
    Set mod1 = Nothing

End Sub

Public Function GetDeclaration(mdl As Module) As String
'Return declaration section of module
    Dim lngCountDecl As Long

' Count lines in Declaration section in module.
    lngCountDecl = mdl.CountOfDeclarationLines

    GetDeclaration = mdl.Lines(1, lngCountDecl)

End Function

Private Function GetPart(strString As String, strSep As String, intPart As Integer) As String
'Recursive function which returns part "intPart" of "strString" with "strSep" as a separator

    Dim intFound As Integer
    Dim intNext  As Integer

    intFound = InStr(1, strString, strSep)
    If intFound > 0 Then
        If intPart = 1 Then
            GetPart = Mid$(strString, 1, intFound - 1)
        Else 'intPart > 1
            GetPart = GetPart(Mid$(strString, intFound + 1), strSep, intPart - 1) 'recursive
        End If
    Else 'intFound = 0, no occurence of seperator so return complete string
        GetPart = strString
    End If

End Function

Public Function GetProcedure(mod1 As Module, strProcname As String) As String
'For this constant: vbext_pk_Proc. A reference need to be added:
'   "Microsoft Visual Basic for Applications Extensibility 5.3"
'Return a procedure in a module.
    Dim intStartProc As Integer
    Dim intProcLines As Integer

    If Len(strProcname) = 0 Then Exit Function

    intStartProc = mod1.ProcStartLine(strProcname, vbext_pk_Proc)
    intProcLines = mod1.ProcCountLines(strProcname, vbext_pk_Proc)

    GetProcedure = mod1.Lines(intStartProc, intProcLines)

End Function

Private Sub InsertIntoForms(strFormname As String)
    Dim mod1 As Module, strType As String

'If Form has module, set reference to it
'and insert line into the module.
'Free reference resource when done.
    If Forms(strFormname).HasModule = True Then
        Set mod1 = Forms(strFormname).Module
        strType = "'Form Class Module"
        mod1.InsertLines 1, strType
        Set mod1 = Nothing
    End If
End Sub

Public Sub InsertIntoModules(strModname As String)
    Dim strType As String, mod1 As Module

    Set mod1 = Modules(strModname)

'Detect module type to determine which
'string to insert.
    If mod1.Type = 0 Then
        strType = "'Standard Module"
    Else
        strType = "'Class Module"
    End If
    mod1.InsertLines 1, strType
    Set mod1 = Nothing
End Sub

Public Sub ListAllModulesByTypeAndClassForms()
    Dim obj1 As AccessObject, dbs1 As Object
    Dim mod1 As Module, frm1 As Form

    Set dbs1 = Application.CurrentProject

'Search for open AccessObject objects in AllModules collection.
'Open and reclose those that are not open.

    For Each obj1 In dbs1.AllModules
        If obj1.IsLoaded = True Then
            ListTypeOfModule obj1.Name
        Else
            DoCmd.OpenModule obj1.Name
            ListTypeOfModule obj1.Name
            DoCmd.Close acModule, obj1.Name
        End If
    Next obj1

'Search for open AccessObject objects in AllForms collection.
'Open and reclose those that are not open.

    For Each obj1 In dbs1.AllForms
        If obj1.IsLoaded Then
            DoesFormHaveModule obj1.Name
        Else
            DoCmd.OpenForm obj1.Name
            DoesFormHaveModule obj1.Name
            DoCmd.Close acForm, obj1.Name
        End If
    Next obj1
End Sub

Private Sub ListTypeOfModule(modname)
    Dim strType As String

'Decode module Type value.
    If Modules(modname).Type = 0 Then
        strType = "Standard Module"
    Else
        strType = "Class Module"
    End If

'Print module name and type.
    Debug.Print Modules(modname).Name & vbTab & strType
End Sub

Private Function OpenModule(strModname) As Module

    Dim obj1         As AccessObject
    Dim mod1         As Module

    For Each obj1 In Application.CurrentProject.AllModules
        If obj1.Name = strModname Then
            If Not obj1.IsLoaded Then
                DoCmd.OpenModule obj1.Name
            End If
            Set mod1 = Modules(obj1.Name)
            Exit For
        End If
    Next obj1

    Set OpenModule = mod1

End Function

Private Sub Quick_Sort(ByRef aSortArray As Variant, ByVal lngFirst As Long, ByVal lngLast As Long)
'Recursive array quicksort function single dimension

    Dim lngLow As Long, lngHigh As Long
    Dim vntTemp As Variant, vntList_Separator As Variant

    lngLow = lngFirst
    lngHigh = lngLast

    vntList_Separator = aSortArray((lngFirst + lngLast) / 2)
    Do
        Do While (aSortArray(lngLow) < vntList_Separator)
            lngLow = lngLow + 1
        Loop
        Do While (aSortArray(lngHigh) > vntList_Separator)
            lngHigh = lngHigh - 1
        Loop
        If (lngLow <= lngHigh) Then
            vntTemp = aSortArray(lngLow)
            aSortArray(lngLow) = aSortArray(lngHigh)
            aSortArray(lngHigh) = vntTemp
            lngLow = lngLow + 1
            lngHigh = lngHigh - 1
        End If
    Loop While (lngLow <= lngHigh)
    If (lngFirst < lngHigh) Then Quick_Sort aSortArray, lngFirst, lngHigh
    If (lngLow < lngLast) Then Quick_Sort aSortArray, lngLow, lngLast

End Sub

Private Sub ReplaceLines(mod1 As Module, lngX As Long, strLine As String)
    mod1.ReplaceLine lngX, strLine
End Sub
Public Function SearchAllModules(strSearchFor As String, Optional blnCloseObjectsAfterwards As Boolean = True) As String
'Search for a string in all modules and return line where it was found
    Dim obj1         As AccessObject
    Dim mod1         As Module
    Dim strType      As String
    Dim strFound     As String
    Dim strHeader    As String
    Dim strRetVal    As String
    Dim blnCloseAfterwards  As Boolean

    On Error GoTo Err_SearchAllModules

    strHeader = "Search for " & strSearchFor
'Loop through AllModules members.
    For Each obj1 In Application.CurrentProject.AllModules
        If Not obj1.IsLoaded Then
            blnCloseAfterwards = True
            DoCmd.OpenModule obj1.Name
        Else
            blnCloseAfterwards = True
        End If
        Set mod1 = Modules(obj1.Name)
        strFound = SearchInModule(mod1, strSearchFor)
        Set mod1 = Nothing

        If Len(strFound) > 0 Then
            If Len(strRetVal) > 0 Then
                strRetVal = strRetVal & vbCrLf & "Module: " & obj1.Name & vbCrLf
            Else
                strRetVal = "Module: " & obj1.Name & vbCrLf
            End If
            strRetVal = strRetVal & strFound
        End If
        If blnCloseObjectsAfterwards Then If blnCloseAfterwards Then DoCmd.Close acModule, obj1.Name
    Next obj1

'Search in CBF
    For Each obj1 In Application.CurrentProject.AllForms
        If Not obj1.IsLoaded Then
            DoCmd.OpenForm obj1.Name, acDesign
            blnCloseAfterwards = True
        Else
            blnCloseAfterwards = False
        End If

        If Forms(obj1.Name).HasModule = True Then
            Set mod1 = Forms(obj1.Name).Module
            strFound = SearchInModule(mod1, strSearchFor)
            Set mod1 = Nothing
        End If

        If Len(strFound) > 0 Then
            If Len(strRetVal) > 0 Then
                strRetVal = strRetVal & vbCrLf & "Module in form: " & obj1.Name & vbCrLf
            Else
                strRetVal = "Module in form: " & obj1.Name & vbCrLf
            End If
            strRetVal = strRetVal & strFound
        End If
        If blnCloseObjectsAfterwards Then If blnCloseAfterwards Then DoCmd.Close acForm, obj1.Name
    Next obj1

    If Len(strRetVal) = 0 Then
'        strRetVal = "Not used"
    Else
        strRetVal = strRetVal & vbCrLf & strHeader
    End If

    SearchAllModules = strRetVal

Exit_SearchAllModules:
    Exit Function
Err_SearchAllModules:
    ErrorProc Err, Err.Description, "SearchAllModules", "basX"
    Resume Exit_SearchAllModules
    Resume
End Function

Private Function SearchInCBF1(obj1 As AccessObject, _
strSearchFor As String, _
Optional strPrefix As String = "   ") As String

    Dim mod1                As Module
    Dim strRetVal           As String
    Dim strModname          As String
    Dim blnCloseAfterwards  As Boolean

    strModname = obj1.Name

    If Not obj1.IsLoaded Then
        DoCmd.OpenForm obj1.Name, acDesign
        blnCloseAfterwards = True
    Else
        blnCloseAfterwards = False
    End If

    If Forms(obj1.Name).HasModule = True Then
        Set mod1 = Forms(obj1.Name).Module
        strRetVal = SearchInModule(mod1, strSearchFor)
        Set mod1 = Nothing
    End If

    If blnCloseAfterwards Then DoCmd.Close acForm, obj1.Name

    SearchInCBF1 = strRetVal

End Function

Private Function SearchInCode(mod1 As Module, strSearchFor As String, Optional blnWholeWord As Boolean = True) As String
'Search for string in mod1
    Dim strRetVal          As String
    Dim lngLine            As Long
    Dim lngMaxLine         As Long
    Dim lngsavedLinenumber As Long
    Dim strProcname        As String

    lngMaxLine = mod1.CountOfLines

    Do While mod1.Find(strSearchFor, lngLine, 1, lngMaxLine, 80, blnWholeWord) = True
        If lngsavedLinenumber <= lngLine Then
            strProcname = mod1.ProcOfLine(lngLine, vbext_pk_Proc)
            Debug.Print lngLine & ": " & strProcname & ": " & mod1.Lines(lngLine, 1)
            lngLine = lngLine + 1
            lngsavedLinenumber = lngLine
        Else
            Exit Do
        End If
    Loop

End Function
Public Function SearchForProcedure(strSearchFor As String) As String
'This function returns all modules names and or formnames where the prcedure name is found
    
    Dim oMod    As AccessObject
    Dim oFrm    As AccessObject
    Dim mod1    As Module
    Dim aProc() As String
    Dim intMin  As Integer
    Dim intMax  As Integer
    Dim intTel  As Integer
    Dim blnCls  As Boolean

'loop through all forms
    For Each oFrm In Application.CurrentProject.AllForms
        blnCls = False
        If Not oFrm.IsLoaded Then
            DoCmd.OpenForm oFrm.Name
            blnCls = True
        End If
              
        If Forms(oFrm.Name).HasModule = True Then
            Set mod1 = Forms(oFrm.Name).Module
            aProc = AllProcs(mod1)
            intMin = LBound(aProc, 1)
            intMax = UBound(aProc, 1)
            For intTel = intMin To intMax
                If aProc(intTel) = strSearchFor Then
                    Debug.Print oFrm.Name & " - " & strSearchFor & " gevonden"
                End If
            Next intTel
            If blnCls Then DoCmd.Close acForm, oFrm.Name
        End If
    Next oFrm

'loop through all modules.
    For Each oMod In Application.CurrentProject.AllModules
        blnCls = False
'      Debug.Print oMod.Name & vbTab & oMod.Type & vbTab & oMod.IsLoaded
        If Not oMod.IsLoaded Then
            blnCls = True
            DoCmd.OpenModule oMod.Name
        End If
        aProc = AllProcs(Modules(oMod.Name))
        intMin = LBound(aProc, 1)
        intMax = UBound(aProc, 1)
        For intTel = intMin To intMax
            If aProc(intTel) = strSearchFor Then
                Debug.Print oMod.Name & " - " & strSearchFor & " gevonden"
            End If
        Next intTel
        If blnCls Then DoCmd.Close acModule, oMod.Name
    Next oMod

End Function

Private Function SearchInModule(mod1 As Module, _
                       strSearchFor As String, _
                 Optional strPrefix As String = "   ") As String
'Search string in module.
    Dim intI            As Integer
    Dim strModname      As String
    Dim astrProcNames() As String
    Dim strProcedure    As String
    Dim strRetVal       As String
    Dim strLine         As String
    Dim StartLine       As Long
    Dim StartColumn     As Long
    Dim EndLine         As Long
    Dim EndColumn       As Long
   
    strModname = mod1.Name

    astrProcNames = AllProcs(mod1)

    If mod1.Find(strSearchFor, StartLine, StartColumn, EndLine, EndColumn, True, False) Then
        strProcedure = mod1.ProcOfLine(StartLine, vbext_pk_Proc)
        strLine = GetLine(mod1, StartLine)
        strRetVal = strProcedure & ": " & strLine
    End If

    SearchInModule = strRetVal

End Function

Private Function SearchInQueryDefs(strSearch As String, Optional blnSilent As Boolean = False) As Boolean

    Dim qdf      As QueryDef
    Dim qdfs     As QueryDefs
    Dim blnFound As Boolean

    Set qdfs = CurrentDb.QueryDefs

    For Each qdf In qdfs
'      Debug.Print "Searching : " & qdf.Name & "...";
        blnFound = InStr(1, qdf.sql, strSearch) > 0
        If blnFound Then
            If Not blnSilent Then
                Debug.Print "Searching : " & qdf.Name & "...";
                Debug.Print " - found"
                If vbNo = MsgBox("Gevonden!" & vbCrLf & vbCrLf & "" & strSearch & " gevonden in " & qdf.Name & vbCrLf & vbCrLf & qdf.sql & "" & vbCrLf & vbCrLf & "Klik 'Ja' om verder te zoeken, 'Nee' om te stoppen", vbExclamation + vbYesNo, "SearchInQueryDefs") Then
                    Exit Function
                End If
            Else
                SearchInQueryDefs = True
                Exit Function 'Once found exit function
            End If
        Else
            SearchInQueryDefs = False
        End If
    Next qdf

    If Not blnSilent Then
        MsgBox "Done searching.", vbInformation
    End If

End Function

Public Sub SortAllProcsInModule(strModname As String)
    SortProcs Modules(strModname)
End Sub

Public Function SortProcs(mdl As Module) As Variant

    Dim intI            As Integer
    Dim lngCount        As Long
    Dim astrProcNames() As String
    Dim strSortedProcs  As String

    lngCount = mdl.CountOfLines
    astrProcNames = AllProcs(mdl)

'Sorted:
    Quick_Sort astrProcNames, LBound(astrProcNames, 1), UBound(astrProcNames, 1)

    SortProcs = astrProcNames

'Output sorted functions into variable
'First declaration part
    strSortedProcs = GetDeclaration(mdl)

'Now all functions and procedures
    For intI = 0 To UBound(astrProcNames)
        strSortedProcs = strSortedProcs & vbCrLf & GetProcedure(mdl, astrProcNames(intI))
    Next intI

'Delete all the lines in the module
    mdl.DeleteLines 1, lngCount
'Rewrite the module.
    mdl.InsertLines 1, strSortedProcs

End Function

Public Sub TextSearchInCode(strSearchFor As String, strModname As String)
'Text search in code and return line.
    Dim mod1 As Module
    Dim obj1 As AccessObject

'Loop through AllModules members.
'If module is open, call sub to delete line;
'else open module first, then close afterwards.
    For Each obj1 In Application.CurrentProject.AllModules
        If obj1.Name = strModname Then
            If obj1.IsLoaded = True Then
                Set mod1 = Modules(strModname)
                Debug.Print SearchInCode(mod1, strSearchFor)
            Else
                DoCmd.OpenModule obj1.Name
                Set mod1 = Modules(strModname)
                Debug.Print SearchInCode(mod1, strSearchFor)
                DoCmd.Close acModule, obj1.Name
            End If
            Exit For
        End If
    Next obj1

End Sub


Public Sub XrefQueriesInFormCode()
'Loop through all queries to see if their name is used in queries.
'Default only the queries not used in queries are shown.

    Dim qdf As QueryDef
    Dim blnFound As Boolean
    Dim strRetVal As String

    For Each qdf In CurrentDb.QueryDefs
        If VBA.Left$(qdf.Name, 4) <> "~sq_" Then
            strRetVal = SearchAllModules(qdf.Name, False)
            blnFound = Len(strRetVal) > 0
            If blnFound Then
                Debug.Print strRetVal
            End If
        End If
    Next qdf

    If MsgBox("Close all forms?", vbQuestion + vbYesNo, GetAppTitle) = vbYes Then CloseAllForms

    MsgBox "Done!", vbInformation, "XrefQueriesInFormCode: Search completed"
End Sub

Public Sub XrefQueriesInQueries(Optional blnUsed As Boolean = False)
'Loop through all queries to see if their name is used in queries.
'Default only the queries not used in queries are shown.

    Dim qdf As QueryDef
    Dim blnFound As Boolean

    For Each qdf In CurrentDb.QueryDefs
        If VBA.Left$(qdf.Name, 4) <> "~sq_" Then
            blnFound = SearchInQueryDefs(qdf.Name, True)
            If blnFound And blnUsed Then
                Debug.Print "In use: "; qdf.Name
            ElseIf Not blnFound And Not blnUsed Then
                Debug.Print "Not in use: "; qdf.Name
            End If
        End If
    Next qdf
    MsgBox "Done!", vbInformation, "XrefQueriesInQueries: Search completed"
End Sub

Public Sub XrefTablesInQueries(Optional blnUsed As Boolean = False)
'Loop through all tables to see if their name is used in queries.
'Default only the tables not used in queries are shown.

    Dim tdf      As TableDef
    Dim blnFound As Boolean

    For Each tdf In CurrentDb.TableDefs
        If VBA.Left$(tdf.Name, 4) <> "MSys" Then
            blnFound = SearchInQueryDefs(tdf.Name, True)
            If blnFound And blnUsed Then
                Debug.Print "In use: "; tdf.Name
            ElseIf Not blnFound And Not blnUsed Then
                Debug.Print "Not in use: "; tdf.Name
            End If
        End If
    Next tdf
    MsgBox "Done!", vbInformation, "XrefTablesInQueries: Search completed"
End Sub

Public Function ProcedureBody(mod1 As Module, _
                   ByRef strHeader As String, _
                     ByRef strBody As String, _
                   ByRef strFooter As String, _
                  Optional lngLine As Long = 0, _
              Optional strProcname As String = "") As String
'Return the body of the procedure you're in.
'
    Dim lngStartLine  As Long
    Dim lngCountLines As Long
    
    If Len(strProcname) = 0 Then
        strProcname = mod1.ProcOfLine(lngLine, vbext_pk_Proc)
    End If
    
    lngStartLine = mod1.ProcStartLine(strProcname, vbext_pk_Proc) + 1
    lngCountLines = mod1.ProcCountLines(strProcname, vbext_pk_Proc) - 1
                
    ProcedureBody = mod1.Lines(lngStartLine, lngCountLines)

End Function

Public Sub AddErrorHandler(mod1 As Module, lngLine As Long)

    On Error GoTo Err_AddErrorHandler
    
Exit_AddErrorHandler:
    Exit Sub
    
Err_AddErrorHandler:
    ErrorProc Err, Error$, "AddErrorHandler", "basX"
    Resume Exit_AddErrorHandler
    
End Sub
Public Function GetLine(mod1 As Module, lngLine As Long, Optional lngLines As Long) As String
'Ignore line continuation characters, get the complete line

    Dim strLine As String
    Dim lngX    As Long

    lngX = 0
    Do
        lngX = lngX + 1
        strLine = mod1.Lines(lngLine, lngX)
    Loop Until VBA.Right$(strLine, 1) <> "_"
        
    lngLines = lngX
    GetLine = strLine

End Function
Private Sub aap()
    Dim lngLines As Long
    Debug.Print GetLine(Modules("basX"), 881, lngLines)
    Debug.Print lngLines
    Debug.Print GetLine(Modules("basX"), 881 + lngLines, lngLines)
End Sub

Public Sub AddLineNumbers(mod1 As Module, Optional lngStartNumber As Long = 1, Optional intPositions As Integer = 3)



End Sub
Public Sub RemoveLineNumbers(mod1 As Module)



End Sub

